/*
 * Copyright Contributors to the fusa-gcc-plugin project
 *
 * SPDX-License-Identifier: LGPL-2.1-or-later
 */
#pragma once

#include <optional>

#include "gcc-plugin.h"

#include "cpplib.h"

using namespace std;

namespace macrohelpers {
struct macro {
  string name;
  string file_name;
  location_t where;
};

struct loc_map_pair {
  const line_map_macro *map;
  location_t where;
};

// Get possible macro metadata for a specific location, loosely inspired by
// diagnostic.cc
optional<macro> get_macro_expansion(location_t where);
}; // namespace macrohelpers
